{ ------------------------------------------------------------------------------------------------------------------- }
{                                                                                                                     }
{ Die Unit stellt einen inhaltslosen Datentypen TAVLBaum zur Verfgung. Um einen AVL-Baum mit Inhalt zu erhalten,     }
{ muss eine hiervon abgeleitete Klasse erstellt werden, z. B.:                                                        }
{                                                                                                                     }
{  type TIntAVLBaum = class(TAVLBaum)                                                                                 }
{         public                                                                                                      }
{           Wurzelinhalt: integer;                                                                                    }
{           constructor Create(w: Integer);                                                                           }
{           function equal(e: TSuchbaum): boolean; override;        // Diese stammt noch von TSuchbaum                }
{           function higher(e: TSuchbaum): boolean; override;       // Diese ebenfalls                                }
{           function WurzelinhaltToString: string; override;                                                          }
{       end;                                                                                                          }
{                                                                                                                     }
{  Die Routinen equal (gleich) und higher (grer) dienen zur Einsortierung in den Such- bzw. AVL-Baum.               }
{                                                                                                                     }
{ -------------------------------------------------------------------------- Tool zum AVL-Baum, (C) 2002 D. Garmann - }

unit Avlbaum;

interface

uses ExtCtrls, suchbaum;

type TAVLBaum=class(TSuchBaum)
       private
         Hoehe: integer;
           { Damit die Hhe nicht immer rekursiv berechnet werden muss, wird sie lokal in jedem Knoten gespeichert    }

         function IsoliereGroesstesElement(var grElem: TAVLbaum): TAVLbaum;
           { Liefert den AVLBaum ohne das groesste Element. Dieses steht abgekapselt in grElement                     }
         function EchtLoeschen: TAVLbaum;
           { Liefert den neuen AVLbaum ohne das zuvor existierende (!!!) Suchelement e                                }
         function AVLKorrektur: TAVLBaum;
           { Liefert den - falls ntig - hhenbalancierten AVLbaum                                                    }
         procedure Aktualisiere_Hoehe;
           { Aktualisiert die Variable Hoehe                                                                          }

       public
         constructor create;
         function Balance: integer;
           { Liefert die Balance (rechterTeilbaum.Hoehe - linkerTeilbaum.Hoehe)                                       }
         function BaumHoehe: integer;
           { Liefert den Wert der privaten Variablen Hoehe                                                            }
         function AVLEinfuegen(e: TAVLBaum; var ExistiertBereits: boolean): TAVLBaum;
           { Liefert den neuen AVLBaum mit dem eingefgten Suchelement                                                }
         function AVLLoeschen(e: TAVLBaum; var Existiert: boolean): TAVLBaum;
           { Liefert den neuen AVLBaum ohne das eventuell vorhandene Suchelement e                                    }
           { war es nicht vorhanden => Existiert = false                                                              }

     end;

implementation

constructor TAVLBaum.create;
begin
  inherited create;
  Hoehe:= 1;
end;

function TAVLBaum.Balance: integer;
begin
  if leer
    then Balance:= 0
    else Balance:= (rechterTeilbaum as TAVLBaum).Baumhoehe - (linkerTeilbaum as TAVLBaum).Baumhoehe;
end;

function TAVLBaum.Baumhoehe: integer;
begin
  if leer
    then Baumhoehe:= 0
    else Baumhoehe:= Hoehe;
end;

procedure TAVLBaum.Aktualisiere_Hoehe;
begin
  if not leer
  then
  if (rechterTeilbaum as TAVLBaum).Baumhoehe >
     (linkerTeilbaum as TAVLBaum).Baumhoehe
       then Hoehe:= (rechterTeilbaum as TAVLBaum).Baumhoehe + 1
       else Hoehe:= (linkerTeilbaum as TAVLBaum).Baumhoehe + 1;
end;

function TAVLBaum.AVLKorrektur: TAVLBaum;
var x,y,z, b1, b2, b3, b4: TAVLBaum;
begin
  case Balance of
   -1,0,1: AVLKorrektur:= Self;                                          { Bei Balance in -1,0,1 ist alles ok.        }
       -2: begin                                                         { Linkslastig:                               }
             case (LinkerTeilbaum as TAVLBaum).Balance of
               -1: begin                                                 {   stark Auenlastig:                       }


                   end;
                0: begin                                                 {   schwach Auenlastig:                     }


                   end;
               +1: begin                                                 {   Innenlastig:                             }


                   end;
             end;
           end;
       +2: begin
             case (RechterTeilbaum as TAVLBaum).Balance of
                +1: begin


                    end;






             end;
           end;
  end;
end;

function TAVLBaum.AVLEinfuegen(e: TAVLBaum; var ExistiertBereits: boolean): TAVLBaum;
var tb: TAVLBaum;
begin





end;


    function TAVLBaum.IsoliereGroesstesElement(var grElem: TAVLBaum): TAVLBaum;
    var tb: TAVLBaum;
    begin







    end;

  function TAVLBaum.EchtLoeschen: TAVLBaum;
  var grElement: TAVLBaum;                                               { grtes Element im linken Teilbaum         }
      tb: TAVLBaum;
  begin






  end;


function TAVLBaum.AVLLoeschen(e: TAVLBaum; var Existiert: boolean): TAVLBaum;
var tb: TAVLBaum;
begin



end;

end.
